# Interface QuotingStrategy

All Known Implementing Classes:
  `DefaultQuotingStrategy`

public interface QuotingStrategy
Encapsulates a database-specific SQL identifier quoting style (the start and end quote characters).

Since:
  4.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final QuotingStrategy`
  `NONE`
  A shared no-quote instance that appends identifiers verbatim.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `appendEnd(Appendable out)`
  Appends the end-quote delimiter (e.g.
  `default void`
  `appendFQN(Appendable out, String... parts)`
  Appends a fully-qualified name, joining non-empty parts with `'.'` and wrapping each part in start/end quotes.
  `void`
  `appendStart(Appendable out)`
  Appends the start-quote delimiter (e.g.
  `default String`
  `quoted(String identifier)`
  Returns a single quoted identifier.
  `default String`
  `quotedFQN(String... parts)`
  Returns a quoted fully-qualified name, joining non-empty parts with `'.'` and wrapping each part in start/end quotes.

- ## Field Details

  - ### NONE

    static final QuotingStrategy NONE
    A shared no-quote instance that appends identifiers verbatim. Used wherever SQL identifier quoting is disabled.

- ## Method Details

  - ### appendStart

    void appendStart(Appendable out)
    Appends the start-quote delimiter (e.g. `"`, `[` or ```). A no-op when quoting is off.
    Since:
      5.0

  - ### appendEnd

    void appendEnd(Appendable out)
    Appends the end-quote delimiter (e.g. `"`, `]` or ```). A no-op when quoting is off.
    Since:
      5.0

  - ### appendFQN

    default void appendFQN(Appendable out, String... parts)
    Appends a fully-qualified name, joining non-empty parts with `'.'` and wrapping each part in start/end quotes. `null` and empty parts are skipped (e.g. an absent catalog reported as an empty string by JDBC metadata).
    Since:
      5.0

  - ### quoted

    default String quoted(String identifier)
    Returns a single quoted identifier.
    Since:
      5.0

  - ### quotedFQN

    default String quotedFQN(String... parts)
    Returns a quoted fully-qualified name, joining non-empty parts with `'.'` and wrapping each part in start/end quotes. `null` and empty parts are skipped.
    Since:
      5.0